clear all
clf

xdim = 7; ydim = 5;
% Komponenten der Sttzstellen
x=linspace(-1,1,xdim)';
y=linspace(0,3,ydim);

% % Diskretisierung des [-1,1]x[0,3] zur Auswertung
s=linspace(-1,1,10*xdim);
t=linspace(0,3,10*ydim);

% Die Sttzstellenwerte
F=zeros(length(x),length(y)); F(4,3) = 1;

% Hilfsmatrix
C=zeros(length(x),length(y));

% Berechnung der q_i(y(j))
for j=1:ydim
    % Berechnung der q_1(y(j)),q_2(y(j)),...,q_m(y(j))
    % als Newton-Basis-Koeffizienten
    C(:,j) = hermite(x,F(:,j));
end

% berschreiben von C durch die Newton-Basis-Koeffizienten
% von q_1,...q_m
for k=1:xdim
    C(k,:) = hermite(y,C(k,:)')';
end

% Auswertung des Polynoms an den Stellen (s(k),t(l))
P2 = zeros(length(s),length(t));
q=zeros(length(x),1);
for ell=1:length(t)
    % Berechnung von q_1(t(ell)),q_2(t(ell)),...,q_m(t(ell))
    for i=1:xdim
        q(i) = horner(t(ell),C(i,:)',y);
    end
    % Berechnung von p(s(1),t(ell)),...,p(s(r),t(ell))  
    for k=1:length(s)
        P2(k,ell) = horner(s(k),q,x);
    end
end

% Plot des Interpolanten
surf(s,t,P2','Edgecolor','none')
hold on

% Plot der Sttzpunkte
[X,Y] = meshgrid(x,y);
plot3(X,Y,F','k*')

% Zum Vergleich mit dem Interpolanten aus 14(iii)
% gegebenfalls "clear all" entfernen
% max(max(abs(P-P2)))